
import java.io.*;
import javax.sound.sampled.*;

/* Passa baixa de 2 estagios para arquivos wav com amostra de 8 bits */
public class PassaBaixa
{
  private AudioInputStream entrada = null;
  private SourceDataLine fonteSonora;
  private AudioFormat formatoDaEntrada;
  private DataLine.Info descricaoDaEntrada;
  private long tamanhoStream;
  private int tamanhoFrame;

    public PassaBaixa(String nomeArq)
    {
      try
      {
        //preparando a criacao de um SourceDataLine
        entrada = AudioSystem.getAudioInputStream(new File(nomeArq));
        formatoDaEntrada = entrada.getFormat();
        descricaoDaEntrada = new DataLine.Info(SourceDataLine.class, formatoDaEntrada);
        fonteSonora = (SourceDataLine) AudioSystem.getLine(descricaoDaEntrada);

        //armazenando informacoes importantes para salvamento posterior
        tamanhoStream = entrada.getFrameLength();
        tamanhoFrame = formatoDaEntrada.getFrameSize();
      }
      catch (Exception e)
      {
        e.printStackTrace();
      }
   }

   public void Executa(String path)
   {
      int tamanhoArray = (int) (tamanhoStream*tamanhoFrame)/2;
      byte[] inAux = new byte[tamanhoArray];
      byte[] outAux = new byte[tamanhoArray];
      int  amostraAtual=0, amostraAnterior=0;
      int numBytesLidos;
      

      try
		{
        //Criar um arquivo temporario
        ByteArrayOutputStream streamResultado = new ByteArrayOutputStream();
        

        //preparar o SourceDataLine para tocar
        fonteSonora.open();
        //garante que nao vai ter lixo na memoria
        fonteSonora.flush();
        fonteSonora.start();
        
        
        while ((numBytesLidos = entrada.read(inAux)) != -1)
        {
          for(int i=0; i <numBytesLidos;i++)
          {
            amostraAnterior = amostraAtual;
            /*
            Arquivos wav com 8 bits, em diferentemente dos outros, possui codificacao
            PCM_UNSIGNED. Byte por sua vez, eh signed, uma forma de resolver o problema
            eh usar operadores bitwise, que, logicamente, nao levam sinal em consideracao.
            */
            amostraAtual = (inAux[i]&0xFF);
            
            //passa baixa de 2 estagios
            outAux[i] =  (byte) ((amostraAnterior*0.5) + (amostraAtual*0.5));
            
          }//for

           //reproduz o som
           fonteSonora.write(outAux,0,numBytesLidos);

           //escreve no arquivo temporario
           streamResultado.write(outAux,0, numBytesLidos);

        } //while

        //libera o stream
        streamResultado.close();

        //abre o arquivo escrito pelo streamTemp como AudioInputStream
        AudioInputStream entradaFiltrada =  new AudioInputStream(
                                                  new ByteArrayInputStream(streamResultado.toByteArray()),
                                                  formatoDaEntrada,
                                                  tamanhoStream);


        FileOutputStream arqSaida = new FileOutputStream(path);

        AudioSystem.write(entradaFiltrada,AudioFileFormat.Type.WAVE,arqSaida);

        entradaFiltrada.close();

	   }
		catch (Exception e)
		{
			System.out.println(e);
		}
	}

   public static void main(String args[])
   {
      PassaBaixa f = new PassaBaixa("welcome_8.wav");
      f.Executa("welcome_baixa.wav");
      System.out.println("acabou");
   }
}

